import 'package:c8y_client/src/alarms/implementations/paged_alarm_collection_representation.dart';
import 'package:c8y_client/src/alarms/model/alarm_collection.dart';
import 'package:c8y_client/src/alarms/model/alarm_collection_represenation.dart';
import 'package:c8y_client/src/alarms/model/alarm_media_type.dart';
import 'package:c8y_client/src/alarms/model/alarm_representation.dart';
import 'package:c8y_client/src/core/implementations/paged_resource_collention.dart';
import 'package:c8y_client/src/core/model/cumulocity_media_type.dart';
import 'package:c8y_client/src/sdk/client/rest_connector.dart';

class AlarmCollectionImpl extends PagedResourceCollectionImpl<
    AlarmRepresentation,
    AlarmCollectionRepresentation,
    PagedAlarmCollectionRepresentation> implements AlarmCollection {
  AlarmCollectionImpl(RestConnector restConnector, String path, int pageSize)
      : super(restConnector, path, pageSize);

  @override
  CumulocityMediaType mediaType() {
    return AlarmMediaType.ALARM_COLLECTION;
  }

  @override
  AlarmCollectionRepresentation parser(Map<String, Object> json) {
    return AlarmCollectionRepresentation.fromJson(json);
  }

  @override
  PagedAlarmCollectionRepresentation wrap(
      AlarmCollectionRepresentation collection) {
    return PagedAlarmCollectionRepresentation(collection, this);
  }
}
