import 'dart:async';

import 'package:c8y_client/src/alarms/model/alarm_collection_represenation.dart';
import 'package:c8y_client/src/alarms/model/alarm_representation.dart';
import 'package:c8y_client/src/core/implementations/PagedCollectionStreamable.dart';
import 'package:c8y_client/src/core/model/paged_collection_representation.dart';
import 'package:c8y_client/src/core/model/paged_collection_resource.dart';

class PagedAlarmCollectionRepresentation extends AlarmCollectionRepresentation
    implements
        PagedCollectionRepresentation<AlarmRepresentation,
            AlarmCollectionRepresentation> {
  PagedCollectionResource<AlarmRepresentation, AlarmCollectionRepresentation>
      collectionResource;
  AlarmCollectionRepresentation collection;

  PagedAlarmCollectionRepresentation(this.collection, this.collectionResource) {
    alarms = collection.alarms;
    pageStatistics = collection.pageStatistics;
    self = collection.self;
    next = collection.next;
  }

  @override
  StreamIterator<AlarmRepresentation> allPages() {
    return PagedCollectionStreamable(collectionResource, collection, 0);
  }

  @override
  StreamIterator<AlarmRepresentation> elements(int limit) {
    return PagedCollectionStreamable(collectionResource, collection, limit);
  }
}
