import 'dart:async';

import 'package:c8y_client/src/alarms/model/alarm_representation.dart';
import 'package:c8y_client/src/core/model/id.dart';

abstract class AlarmApi {

  Future<AlarmRepresentation> create(AlarmRepresentation alarm);

  Future<AlarmRepresentation> update(AlarmRepresentation alarm);

  Future<AlarmRepresentation> get(ID id);

  Future<List<AlarmRepresentation>> listAll(Map<String, Object> queryParams);

  Future<List<AlarmRepresentation>> listByLimit(Map<String, Object> queryParams, int limit);

  Future<StreamIterator<AlarmRepresentation>> stream(Map<String, Object> queryParams);
}
