import 'package:c8y_client/src/alarms/model/alarm_representation.dart';
import 'package:c8y_client/src/core/model/base_collection.dart';
import 'package:c8y_client/src/core/model/paged_statistics.dart';

class AlarmCollectionRepresentation
    extends BaseCollectionRepresentation<AlarmRepresentation> {
  List<AlarmRepresentation> alarms;

  @override
// TODO: implement pageStatistics
  PageStatistics pageStatistics;
  @override
  String self;
  @override
  String next;

  @override
  Iterator<AlarmRepresentation> get iterator => alarms.iterator;

  AlarmCollectionRepresentation();

  AlarmCollectionRepresentation._full(
      this.pageStatistics, this.self, this.next, this.alarms);

  static AlarmCollectionRepresentation fromJson(
      Map<String, dynamic> json) {
    var statistics = json['statistics'] as Map;
    var next = json['next'] as String;
    var self = json['self'] as String;
    var alarms = json['alarms'] as List;
    alarms = alarms
        .map((alarm) => AlarmRepresentation.fromJson(alarm))
        .toList();
    return AlarmCollectionRepresentation._full(
        PageStatistics.fromJson(statistics), self, next, alarms);
  }
}
