import 'package:c8y_client/src/core/model/document.dart';
import 'package:c8y_client/src/core/model/id.dart';
import 'package:c8y_client/src/core/model/source.dart';

class AlarmRepresentation extends Document {
  Source source;
  String text;
  String severity;
  String status;
  int count;
  DateTime time;
  DateTime _creationTime;
  DateTime _firstOccurrenceTime;
  String type;
  @override
  ID id;

  static AlarmRepresentation fromJson(Map<String, dynamic> json) {

    var id = json['id'] as String;
    json.remove('id');
    var self = json['self'] as String;
    json.remove('self');
    var text = json['text'] as String;
    json.remove('text');
    var severity = json['severity'] as String;
    json.remove('severity');
    var type = json['type'] as String;
    json.remove('type');
    var status = json['status'] as String;
    json.remove('status');
    var count = json['count'] as int;
    json.remove('count');
    var creationTime =
        DateTime.tryParse((json['creationTime'] as String) ?? '');
    json.remove('creationTime');
    var time = DateTime.tryParse((json['time'] as String) ?? '');
    json.remove('time');
    var _firstOccurrenceTime =
        DateTime.tryParse((json['firstOccurrenceTime'] as String) ?? '');
    json.remove('firstOccurrenceTime');
    var jsonSource = json['source'] as Map<String, Object>;
    var fragments = json;
    return AlarmRepresentation()
      ..id = ID(id)
      ..source = Source.fromJson(jsonSource)
      ..severity = severity
      ..count = count
      ..text = text
      ..status = status
      ..self = self
      ..type = type
      ..time = time
      .._firstOccurrenceTime = _firstOccurrenceTime
      .._creationTime = creationTime
      ..fragments = fragments;
  }

  static Map<String, String> toJson(AlarmRepresentation alarm) {
    return <String, String>{}
      ..putIfAbsent('text', () => alarm.text ?? '')
      ..putIfAbsent('type', () => alarm.type ?? '')
      ..putIfAbsent('status', () => alarm.status ?? '')
      ..putIfAbsent(
          'time',
          () =>
              alarm.time.toIso8601String() ?? DateTime.now().toIso8601String())
      ..putIfAbsent(
          'source', () => Source.decode(alarm.source).toString() ?? '')
      ..putIfAbsent('severity', () => alarm.severity ?? '');
  }


  @override
  String toString(){
    return toJson(this).toString();
  }
}
