

import 'dart:async';

import 'package:c8y_client/src/core/implementations/PagedCollectionStreamable.dart';
import 'package:c8y_client/src/core/model/paged_collection_representation.dart';
import 'package:c8y_client/src/core/model/paged_collection_resource.dart';
import 'package:c8y_client/src/inventory/model/managed_object_collection_representation.dart';
import 'package:c8y_client/src/inventory/model/managed_object_representation.dart';

class PagedManagedObjectCollectionRepresentation
    extends ManagedObjectCollectionRepresentation
    implements
        PagedCollectionRepresentation<ManagedObjectRepresentation,
            ManagedObjectCollectionRepresentation> {
  PagedCollectionResource<ManagedObjectRepresentation,
      ManagedObjectCollectionRepresentation> collectionResource;
  ManagedObjectCollectionRepresentation collection;

  PagedManagedObjectCollectionRepresentation(
      this.collection, this.collectionResource) {
    managedObjects = collection.managedObjects;
    pageStatistics = collection.pageStatistics;
    self = collection.self;
    next = collection.next;
  }


  @override
  StreamIterator<ManagedObjectRepresentation> allPages()  {
     return PagedCollectionStreamable(collectionResource, collection,
            0);
  }

  @override
  StreamIterator<ManagedObjectRepresentation> elements(int limit)  {
    return PagedCollectionStreamable(collectionResource, collection, limit);
  }


}
