import 'dart:async';

import 'package:c8y_client/src/core/model/id.dart';
import 'package:c8y_client/src/inventory/model/managed_object_representation.dart';

import 'managed_object_collention.dart';

abstract class InventoryApi {
  ManagedObjectCollection managedObjects();

  Future<StreamIterator<ManagedObjectRepresentation>> stream(
      Map<String, String> queryParams);

  Future<List<ManagedObjectRepresentation>> listAll(Map<String, String> queryParams);

  Future<List<ManagedObjectRepresentation>> listByLimit(
      Map<String, String> queryParams, int limit);

  Future<ManagedObjectRepresentation> get(ID id);

  Future delete(ID id);

  Future<ManagedObjectRepresentation> update(
      ManagedObjectRepresentation managedObject);

  Future<ManagedObjectRepresentation> create(
      ManagedObjectRepresentation managedObject);
}
