import 'package:c8y_client/src/core/model/document.dart';
import 'package:c8y_client/src/core/model/id.dart';
import 'package:c8y_client/src/inventory/implementations/managed_object_reference_collection_representation.dart';

class ManagedObjectRepresentation extends Document {
  String type;
  String name;
  DateTime lastUpdated;
  DateTime creationTime;
  String owner;
  @override
  ID id;
  @override
  String self;

  ManagedObjectReferenceCollectionRepresentation childDevices;
  ManagedObjectReferenceCollectionRepresentation childAssets;
  ManagedObjectReferenceCollectionRepresentation childAdditions;
  ManagedObjectReferenceCollectionRepresentation deviceParents;
  ManagedObjectReferenceCollectionRepresentation assetParents;
  ManagedObjectReferenceCollectionRepresentation additionParents;

  ManagedObjectRepresentation();

  static ManagedObjectRepresentation fromJson(Map<String, dynamic> json) {
    var owner = json['owner'] as String;
    json.remove('owner');
    var id = json['id'];
    json.remove('id');
    var self = json['self'] as String;
    json.remove('self');
    var name = json['name'] as String;
    json.remove('name');
    var type = json['type'] as String;
    json.remove('type');
    var creationTime = DateTime.tryParse((json['creationTime'] as String) ?? '');
    json.remove('creationTime');
    var lastUpdated = DateTime.tryParse((json['lastUpdated'] as String) ?? '');
    json.remove('lastUpdated');
    var fragments = json;
    return ManagedObjectRepresentation()
      ..id = ID(id)
      ..name = name
      ..owner = owner
      ..self = self
      ..type = type
      ..creationTime = creationTime
      ..lastUpdated = lastUpdated
      ..fragments = fragments;
  }

  ManagedObjectRepresentation.complete(
      ID id,
      this.type,
      this.name,
      this.lastUpdated,
      this.owner,
      this.childAssets,
      this.childDevices,
      this.childAdditions,
      this.assetParents,
      this.deviceParents,
      this.additionParents);

//  factory ManagedObjectRepresentation.fromJson(Map<String, dynamic> json) {
//    var self = json['self'] as String;
//    json.remove('self');
//    var owner = json['owner'] as String;
//    json.remove('owner');
//
//    return ManagedObjectRepresentation()..owner = owner;
//  }
}
