import 'dart:convert';
import 'package:c8y_client/src/sdk/client/sdk_exception.dart';
import 'package:http_parser/http_parser.dart';
import 'package:http/http.dart';
import 'http_client.dart';
import 'plataform_parameters.dart';
import 'rest_operations.dart';

class RestConnector extends RestOperations {
  Client _httpClient;
  final PlatformParameters _platformParameters;

  RestConnector(this._platformParameters) {
    _httpClient = createClient();
  }

  @override
  Future delete(String var1) {
    // TODO: implement delete
    return null;
  }

  @override
  Future<Object> get(String path, MediaType mediaType, Function parser) async {
    var response = await _getClientResponse(path, mediaType);
    if (response.statusCode != 200) {
      throw (SDKException.withStatusCode(response.statusCode, response.body));
    }
    var jsonData = json.decode(response.body);
    return parser(jsonData);
  }

  Future<Response> _getClientResponse(String url, MediaType mediaType) async {
    var response = await _httpClient.get(url);
    return response;
  }

  @override
  Future<Object> post(
      String path, Map<String, Object> body, Function parser) async {
    var response = await _httpClient.post(path, body: body);
    if (response.statusCode != 201) {
      throw (SDKException.withStatusCode(response.statusCode, response.body));
    }
    var jsonData = json.decode(response.body);
    return parser(jsonData);
  }

  @override
  Future<Object> put(String var1, var2, Function parser) {
    // TODO: implement put
    return null;
  }

  Client createClient() {
    return HTTPClient(Client(), _platformParameters.credentials);
  }
}
